<template>
  <div>
    <ul class="pl-5">
      <b class="text-lg"
        >ยุทธศาสตร์ที่ : {{ stargic.number }} {{ stargic.name }}
        <small class="text-gray-500">
          ( {{ stargic.children.length }}
          โครงการหลัก )
        </small>
      </b>
      <li v-for="project in stargic.children" :key="project.id">
        <ul class="pl-5">
          <b class="text-base"
            >{{ project.name }}
            <small v-if="project.children.length > 0" class="text-gray-500">
              ( {{ project.children.length }}
              โครงการย่อย )
            </small>
            <p v-else class="font-normal">
              <small
                class="text-blue-500 cursor-pointer hover:underline"
                @click="clickOpenDialog(project)"
                >ดูข้อมูล
              </small>
              <small class="text-blue-500 cursor-pointer hover:underline"
                >ดูข้อมูล
              </small>
            </p>
          </b>

          <li v-for="side in project.children" :key="side.id">
            <ul class="pl-5">
              <b>
                {{ side.name
                }}<small v-if="side.children.length > 0" class="text-gray-500">
                  ( {{ side.children.length }}
                  โครงการย่อย )
                </small>
                <p v-else class="font-normal">
                  <small
                    class="text-blue-500 cursor-pointer hover:underline"
                    @click="clickOpenDialog(side)"
                    >ดูข้อมูล
                  </small>
                  <small class="text-blue-500 cursor-pointer hover:underline"
                    >ดูข้อมูล
                  </small>
                </p>
              </b>
              <li v-for="sub_project in side.children" :key="sub_project.id">
                <ul class="pl-5">
                  <li>
                    {{ sub_project.name }}
                  </li>
                  <li>
                    <small
                      class="mr-2 text-blue-500 cursor-pointer hover:underline"
                      @click="clickOpenDialog(sub_project)"
                      >ดูข้อมูล</small
                    >
                    <small class="text-blue-500 cursor-pointer hover:underline"
                      >ดูข้อมูล</small
                    >
                  </li>
                </ul>
              </li>
            </ul>
          </li>
        </ul>
      </li>
    </ul>
  </div>
  <detail-project-dialog
    :project="project"
    :open="dialog"
    @close="dialog = false"
    :windowWidth="width"
    :typWindow="type"
  />
</template>

<script>
import { computed, onMounted, onUnmounted, ref } from "vue";
import DetailProjectDialog from "../Welcome/DetailProjectDialog.vue";
export default {
  components: { DetailProjectDialog },
  props: {
    stargic: Object,
  },
  setup() {
    const isSide = ref(false);

    const project = ref({});
    const dialog = ref(false);
    const clickOpenDialog = (p) => {
      project.value = p;
      dialog.value = true;
    };

    const windowWidth = ref(window.innerWidth);
    const onWidthChange = () => (windowWidth.value = window.innerWidth);
    onMounted(() => window.addEventListener("resize", onWidthChange));
    onUnmounted(() => window.removeEventListener("resize", onWidthChange));

    const type = computed(() => {
      if (windowWidth.value <= 640) return "sm";
      if (windowWidth.value <= 768) return "md";
      if (windowWidth.value <= 1024) return "lg";
      if (windowWidth.value <= 1280) return "xl";
      if (windowWidth.value >= 1536) return "2xl";
    });

    const width = computed(() => windowWidth.value);

    return {
      isSide,
      project,
      dialog,
      clickOpenDialog,
      windowWidth,
      type,
      width,
    };
  },
};
</script>

<style>
</style>
